var fs = require('fs');
const path = require('path');

module.exports = async function (entityfile, json) {
    var entity = await JSON.parse(fs.readFileSync(path.join(__dirname, '../entity/' + entityfile + '.json')));

    for (var key in entity.columns) {
        let fieldname = entity.columns[key];
        if (fieldname.primary && !json[key]) throw '主键(' + key + ')不能为空';
        if ((!fieldname.default && fieldname.default!='') && !fieldname.nullable) {  //如果没有默认值  也不允许为null
            if (!json[key]) throw '(' + key + ')不能为空';
        }
    }
};