const path = require('path');
const fs = require('fs');

module.exports = function (httplogger) {
    return async (ctx, next) => {
        const start = new Date();
        let ms;
        try {
            if (ctx.path == '/log/' || ctx.path == '/log') {  //列出log文件夹中的文件
                if (ctx.method == 'POST') {//如果是post方法,修改lever//todo:增加可以开启关闭log      app.apilogger.level = 'WARN';
                    if (ctx.query.del) {
                        try {
                            await fs.unlinkSync(path.join(__dirname, '../www/log/' + ctx.query.del));
                        } catch (error) {

                        }
                    }
                }
                let pathstr = ctx.path == '/log' ? ctx.path + '/' : ctx.path;
                let files = await fs.readdirSync(path.join(__dirname, '../www/log'));
                let bodystr = '<form action="/log/" method="post"><table><thead><tr><th style="width:30%;">文件</th><th style="width:30%;">尺寸</th><th style="width:30%;">日期</th><th style="width:10%;"></th></tr><thead><tbody>';
                for (let i = 0, len = files.length; i < len; i++) {
                    let file = files[i];
                    const stats = await fs.statSync(path.join(__dirname, '../www/log/' + file));
                    bodystr = bodystr + '<tr><td><a href="' + pathstr + file + '">' + file + '</a></td><td>' + stats.size + '</td><td>' + stats.mtime.toLocaleString() + '</td><td><input type="submit" formaction="/log?del=' + file + '" value="删除" /></td></tr>';
                }
                ctx.body = bodystr + '</tbody></table></form>';
            } else {
                await next(); //开始进入到下一个中间件
            }
            ms = new Date() - start;//记录响应日志
            if (ctx.href.indexOf('/log') < 0) httplogger.info(ms, '-', ctx.status, '-', ctx.length ? ctx.length : 0, '-', ctx.ip, '-', ctx.path);
        } catch (error) {
            ms = new Date() - start;//记录异常日志
            httplogger.error(ms, '-', ctx.status, '-', ctx.length ? ctx.length : 0, '-', ctx.ip, '-', ctx.path, '\r\n', error, );
            ctx.body = error;
        }
    };
};